{Diodes driver by GDR! [http://www.GDR.w.pl/] - for LEDs plugged to
 parrarel (LPT) port - any problems? <gdr@go2.pl> }

{intel outside!}

{Moment... Some preprocessor macros}
{$define noEMULATION}          {If set, emulates all on screen instead of sending it to parrarel port}
                             {to unset, delete this line or change EMULATION into sth else.}

program Diodak;      {Stupid names rule :-}
uses crt;            {CRT sucks... Will be cut as soon as I disable emulation}
const    buf_len=15; {Time buffer lenght - if You change thic, you MUST modify Set_Sat}
         defstattime=50;

     {Variables init...}
var Outb        :array[0..buf_len] of Byte;   {An array of bytes to send to output}
    Position    :longInt;               {For future use}
    Sat         :array[0..buf_len] of Byte;   {Lightness of each LED}
    VLabel      :array[0..10,0..10] of String;
    FName       :array[0..10] of String;
    Diode       :Integer;
    del_blk     :Integer; {Delay between "frames" - in ms, bigger - more blinking}
    div_fac     :Integer;      {Next diode processed after 2^div_fac cycles}
    sin_len_fac :Real; {bigger value -> longer "wave"}
    uni_var1    :Integer;
    uni_var2    :Integer;
    Bad_Key     :Boolean;
    eff         :Word;
    status      :String;
    stattime    :Integer;
    dirty       :Boolean;

{$ifdef EMULATION}
Procedure visualize(out:byte);   {LED emulation on screen [8bit var]}
begin
     gotoxy(32,8);              {~ middle of screen}
     if((out AND   1)<>0) then write('*') else write(' ');
     if((out AND   2)<>0) then write('*') else write(' ');
     if((out AND   4)<>0) then write('*') else write(' ');
     if((out AND   8)<>0) then write('*') else write(' ');
     if((out AND  16)<>0) then write('*') else write(' ');
     if((out AND  32)<>0) then write('*') else write(' ');
     if((out AND  64)<>0) then write('*') else write(' ');
     if((out AND 128)<>0) then write('*') else write(' ');
end;
{$endif}



Procedure SendToPort;    {Now: on screen, later - Send to port}
var loop:integer;

begin
{$ifdef EMULATION}
     for loop:=0 to buf_len do visualize(Outb[loop]);
{$else}
     for loop:=0 to buf_len do
     begin
      Port[$378]:=Outb[loop];
      delay(del_blk);
     end;
{$endif}
end;



Procedure ProcessSaturations;{Convert saturations into byte series}

var l:integer;               {Loop counter = processed bit}
    b:integer;               {Loop counter = processed byte}
    t:integer;               {rmod val}
    tt:real;

begin
     for l:=0 to buf_len do Outb[l]:=0;  {Gotta clear before bitwise OR}
     for l:=0 to 7 do        {Bit  = diode x axis}
     begin
          for b:=0 to buf_len do   {Outb = time axis}
          begin
               if b>0 then
               begin
                 if(Sat[l] > b) THEN Outb[b]:=(outb[b] OR (1 SHL l));
                end
               else if sat[l]=0 then outb[b]:=0;
          end;
     end;
end;

Function ChkVar(v : integer):BOOLEAN;
     begin
          if VLabel[eff,v]='' then ChkVar:=FALSE
          else ChkVar:=TRUE;
     end;

Procedure AddStatus(s:string);
begin
{     if stattime=0 then}
     begin
      Status:=s;
      Stattime:=defstattime;
     end;
end;

Procedure PrintStatus;
var a:integer;
begin
          TextColor(15);
          GotoXY(1,25);
          write(' STATUS : ');
          TextBackground(LIGHTGRAY);
          TextColor(0);
          write(' ');
          if stattime=0 then
          begin
           if((Position mod (defstattime*2))<(defstattime/2)) then write('h for help!')
           else write('Waiting for input...             Visit now : http://www.GDR.w.pl/');
           for a:=Wherex to 78 do write(' ');
          end
          else
          begin
           stattime:=stattime-1;
           if stattime=(defstattime-1) then begin
           Write(Status);
           for a:=Wherex to 78 do write(' ');
           end;
          end;
          TextBackground(BLACK);
          TextColor(7);
end;

Procedure PrintInternalVariables;
var v:integer;
     begin
          TextColor(White);
          GotoXY(10,4);
          Write('Internal variables:');
          TextColor(LightBlue);

          v:=1;
          if ChkVar(v)=TRUE then
          begin
           Gotoxy(30,3);
           Write('[] ');
           Write(VLabel[eff, v]);
           Write(': ',del_blk,'    ');
          end;

         v:=2;
         if ChkVar(v)=TRUE then
         begin
          Gotoxy(30,4);
          Write(';" ');
          Write(VLabel[eff,v]);
          write(': ',sin_len_fac,'    ');
         end;

         v:=3;
         if Chkvar(v)=TRUE then
         begin
          Gotoxy(30,5 );
          Write('<> ');
          Write(VLabel[eff,v]);
          Write(': ',div_fac,'    ');
         end;

         v:=4;
         if Chkvar(v)=TRUE then
         begin
          Gotoxy(30,6);
          Write('-+ ');
          Write(VLabel[eff,v]);
          Write(': ',uni_var1,'    ');
         end;

         v:=5;
         if Chkvar(v)=TRUE then
         begin
          Gotoxy(30,7 );
          Write('09 ');
          Write(VLabel[eff,v]);
          Write(': ',uni_var2,'    ');
         end;

          TextColor(8);
     end;

Function GetFileName:String;
var x:string;
begin
     GotoXY(25,20);
     TextBackground(BLUE);
     Write('Enter file name :                 ');
     GotoXY(43,20);
     readln(x);
     GetFileName:=x;
     TextBackground(BLACK);
end;

Procedure SaveVars(def : Boolean);
var f:Text;
    n:String;
begin
     if def then n:=FName[eff]
     else n:=GetFileName;
     Assign(f,n);
     Rewrite(f);
     Writeln(f, div_fac);
     Writeln(f, sin_len_fac);
     Writeln(f, del_blk);
     Writeln(f, uni_var1);
     Writeln(f, uni_var2);
     Close(f);
     clrscr;
     if def then AddStatus('Saved variables as default')
     else AddStatus('Saved variables to file : '+n);
end;

Procedure LoadVars(def:Boolean);
var f: Text;
    n: String;
begin
     if def then n:=FName[eff]
     else n:=GetFileName;
     Assign(f,n);
     Reset(f);
     Readln(f, div_fac);
     Readln(f, sin_len_fac);
     Readln(f, del_blk);
     Readln(f, uni_var1);
     Readln(f, uni_var2);
     Close(f);
     clrscr;
     if def then AddStatus('Loaded default variables')
     else AddStatus('Loaded variables from file : '+n);
end;

Procedure ChooseEffect;
var key   :char;
    a     :byte;
begin
     clrscr;
     writeln('Choose effect, sinner!');
     a:=0;
     while ((VLabel[a,0]<>'')and(a<11)) do
     begin
     write(a);
     write('. ');
     writeln(VLabel[a,0]);
     a:=a+1;
     end;
     write('Your choice : ');
     repeat until keypressed;
     key:=ReadKey;
          if key='1' then eff:=1
     else if key='2' then eff:=2
     else if key='3' then eff:=3
     else if key='0' then eff:=0
     else eff:=997;
     clrscr;
     dirty:=TRUE;
end;


Procedure ProcessKeyboard;
var       key             :char;
begin
     key:=ReadKey;
     case key of
          '[' : if del_blk>0 then del_blk:=del_blk-1;
          ']' : del_blk:=del_blk+1;
          ';' : if sin_len_fac>0 then sin_len_fac:=sin_len_fac-0.01;
          '''' : sin_len_fac:=sin_len_fac+0.01;
          ',' : if div_fac>0 then div_fac:=div_fac-1;
          '.' : div_fac:=div_fac+1;
          '-' : uni_var1:=uni_var1-1;
          '=' : uni_var1:=uni_var1+1;
          '9' : uni_var2:=uni_var2-1;
          '0' : uni_var2:=uni_var2+1;
          's' : SaveVars(TRUE);
          'w' : SaveVars(FALSE);
          'l' : LoadVars(TRUE);
          'o' : LoadVars(FALSE);
          'h' : AddStatus('s:save w:save as l:load o:load... h:help c:chg eff');
          'c' : ChooseEffect;
          else Bad_Key:=TRUE;
     end;
     if Bad_Key=False then PrintInternalVariables;
end;



Procedure SetSat;
var saturation   :Byte;
    z            :Integer;
begin
     if(position<2147483647) then position:=position+1 else position:=0;
      for Diode:=0 to 7 do
       begin

       if eff=1 then
       begin
         if ((uni_var1+Round(Position/(1 shl div_fac)) mod 16))<8 then
         begin
           if (diode=((uni_var1+Round(Position/(1 shl div_fac))) mod 16)mod 8) then Saturation:=16 else Saturation:=0;
            end
         else
         begin
           if (diode=((15-(uni_var1+Round(Position/(1 shl div_fac))) mod 16))mod 8) then Saturation:=16
           else Saturation:=0;
         end;
       end

       else if eff=2 then
       begin
        saturation:=Round(8*(1+sin((Diode+(Position/(1 shl div_fac)))/sin_len_fac)));
       end

       else if eff=3 then
       begin
        if (position mod 100)<(div_fac) then Saturation:=16 else saturation:=0;
        if(div_fac>100) then
        Begin
         Sound(2000);
         NoSound;
         div_fac:=100;
        End;
       end

       else writeln('Effect not supported.');

      sat[Diode]:=Saturation;

       if eff<>3 then
       begin
        gotoxy(30,Diode+10);
        write('Diode #');
        write(Diode);
        write(' : ');
        write(sat[Diode]);
        write('     ');
        Case Trunc(Saturation/4) of
         0: TextColor(0);
         1: TextColor(8);
         2: TextColor(7);
         3: TextColor(15);
         4: TextColor(14);
        end;
        GotoXY(50,Diode+10);
        write('#');
       end

       else if eff=3 then
       begin
        GotoXY(52,11);
        Write('Sweep:');
        GotoXY(49,13);
        Write('0%');
        GotoXY(59,13);
        Write('100%');
        Case Round(div_fac/25) of
         0: TextColor(8);
         1: TextColor(7);
         2: TextColor(15);
         3: TextColor(14);
         4: TextColor(RED);
        end;
        Gotoxy(50,12);
        write('[');
        Gotoxy(59,12);
        write(']');
        for z:=1 to 8 do begin
         GotoXY(50+z, 12);
         if((div_fac/12)>=z) then
         begin
          if(div_fac mod 12)>=6 then write('#') else if(div_fac/12)<(z+1) then write('|') else write('#');
          end
         else write(' ');
        end;
       end;
        TextColor(7);
       end;
end;

Procedure PreInitArrays;
begin
    VLabel[0,0]:='QUIT';
    FName[0]:='';

    VLabel[1,0]:='Left <-> Right';
    VLabel[1,1]:='del_blk     ';
    VLabel[1,2]:='';
    Vlabel[1,3]:='div_fac      ';
    VLabel[1,4]:='Shift        ';
    FName[1]:='bounce.var';

    VLabel[2,0]:='Sinus wave';
    VLabel[2,1]:='del_blk     ';
    VLabel[2,2]:='sin_len_fac ';
    Vlabel[2,3]:='div_fac     ';
    FName[2]:='sinus.var';

    VLabel[3,0]:='Strobo (variable-sweep square)';
    VLabel[3,1]:='Time        ';
    VLabel[3,2]:='';
    VLabel[3,3]:='Sweep [%]   ';
    FName[3]:='strobo.var';
end;

Procedure PreInit;
begin
    del_blk:=1;
    div_fac:=6;
    sin_len_fac:=3.14;
    Bad_Key:=False;

    PrintInternalVariables;
end;

Procedure InitEff;
begin
     if eff=1 then
     begin
      uni_var1:=16;
     end;
end;

    {Main function}
begin
     PreInitArrays;
     ChooseEffect;
     if eff=997 then ChooseEffect;
     if eff>0 then
     begin
      clrscr;
      GotoXY(0,1);
      write('                 Parrarel port 8 LEDs driver by GDR! <gdr@go2.pl>');
      preInit;
      InitEff;
      repeat        {Every "frame"}
      begin
          SetSat;
          ProcessSaturations;
          SendToPort;
          if Keypressed then ProcessKeyboard;
          PrintStatus;
          if dirty then PrintInternalVariables;
          dirty:=false;
          if eff=0 then bad_key:=TRUE;
      end;
      until bad_key;

      {$ifndef EMULATION}
      Port[$378]:=0;
      {$endif}
     end {eff=0}
     else writeln('QUITTING');
     GotoXY(0,21);
     writeln('');
     writeln('by GDR! <gdr@go2.pl>');
     writeln('intel outside!');
end.


{
        http://www.GDR.w.pl/ - GDR!'s page : programming, c64, comments...

                                    VISIT NOW!                                   }